/*
 * BasicExpression.cpp
 *
 *  Created on: Dec 5, 2012
 *      Author: attero
 */

#include "BasicExpression.h"

void BasicExpression::set_operator(std::string op)
{
	this->oper = op;
}

void BasicExpression::set_left_operand(ASTNode * left)
{
	if(!this->children_set)
	{
		children.push_back(left);
	}
	else
	{
		this->children[0] = left;
	}

	if(children.size() == 2)
		children_set = true;
}

void BasicExpression::set_right_operand(ASTNode * right)
{
	if(!this->children_set)
		{
			children.push_back(right);

		}
		else
		{
			this->children[1] = right;
		}

		if(children.size() == 2)
			children_set = true;
}
void BasicExpression::execute()
{
	children[0]->execute();
	children[1]->execute();
	std::cout << evaluate().repr() << std::endl;
}

SenchaObject BasicExpression::evaluate()
{
	//TODO refactor it ;)
	SenchaObject so;
	if(oper == "+")
	{
		so = SenchaObject(static_cast<ASTExpression *>(children[0])->evaluate() + static_cast<ASTExpression *>(children[1])->evaluate());
	}
	else if(oper == "-")
	{
		so = SenchaObject(static_cast<ASTExpression *>(children[0])->evaluate() - static_cast<ASTExpression *>(children[1])->evaluate());
	}
	else if(oper == "*")
	{
		so = SenchaObject(static_cast<ASTExpression *>(children[0])->evaluate() * static_cast<ASTExpression *>(children[1])->evaluate());
	}
	else if(oper == "/")
	{
		so = SenchaObject(static_cast<ASTExpression *>(children[0])->evaluate() / static_cast<ASTExpression *>(children[1])->evaluate());
	}
	return so;
}

BasicExpression::BasicExpression(ASTNode * parent) {
	this->parent = parent;
	children_set = false;
}

BasicExpression::~BasicExpression() {
	// TODO Auto-generated destructor stub
	// TODO free children memory
}


std::string BasicExpression::debug()
{
	std::string debug_note = "Basic expression:\n";
	debug_note += "left operand: \n";
	debug_note += this->children[0]->debug();
	debug_note += "\nright operand:\n" + this->children[1]->debug();
	debug_note += "\nOperator: " + this->oper +"\n###\n";
	return debug_note;
}
